目录
剑指 Offer 21. 调整数组顺序使奇数位于偶数前面
剑指 Offer 57. 和为s的两个数字
剑指 Offer 58 - I. 翻转单词顺序
剑指 Offer 12. 矩阵中的路径
面试题13. 机器人的运动范围
剑指 Offer 21. 调整数组顺序使奇数位于偶数前面
输入一个整数数组,实现一个函数来调整该数组中数字的顺序,使得所有奇数在数组的前半部分,所有偶数在数组的后半部分。
示例:
输入:nums = [1,2,3,4]
输出:[1,3,2,4]
注:[3,1,2,4] 也是正确的答案之一。【解法一】新建一个数组,先遍历一遍,把奇数尾删入数组,在遍历一遍,偶数入数组
【解法二】双指针(一定要保证元素访问有效)
class Solution { public: vector<int> exchange(vector<int>& nums) { int left = 0; int right = nums.size()-1; while(left<right) { while(left<right && nums[left]%2==1) left++; while(left<right && nums[right]%2==0) right--; swap(nums[left++],nums[right--]); } return nums; } };
剑指 Offer 57. 和为s的两个数字
输入一个递增排序的数组和一个数字s,在数组中查找两个数,使得它们的和正好是s。如果有多对数字的和等于s,则输出任意一对即可。
【解法一】哈希访问 直接被我自己笑死,哈哈哈哈哈
class Solution { public: vector<int> twoSum(vector<int>& nums, int target) { vector<int>res; map<int,int> mp; for(auto &e : nums) { if(mp[target-e]) { res.push_back(e); res.push_back(target-e); return res; } mp[e]++; } return res; } };
【解法二】通过一次遍历每个元素,通过target与每个元素的差值进行二分查找
class Solution { public: bool find(vector<int>& nums, int start, int target) { int end = nums.size(); while(start < end) { int mid = (start+end)/2; if(target > nums[mid]) start = mid + 1; else if(target < nums[mid]) //整一个二分, end = mid; else return true; } return false; } vector<int> twoSum(vector<int>& nums, int target) { vector<int> res; for(int i = 0; i < nums.size(); i++) { int findnum = target - nums[i]; // 利用单值二分查找 if(find(nums, i, findnum)) { res.push_back(nums[i]); res.push_back(findnum); return res; } } return res; } };
【解法三】这个解法和那个二维数组的查找很相似呀,换成一维的……
class Solution { public: vector<int> twoSum(vector<int>& nums, int target) { vector<int> res; int left = 0, right = nums.size()-1; while(left < right) { int add = nums[left]+nums[right]; if(add < target) left++; else if(add > target) right--; else { res.push_back(nums[left]); res.push_back(nums[right]); return res; } } return res; } };
剑指 Offer 58 - I. 翻转单词顺序
输入一个英文句子,翻转句子中单词的顺序,但单词内字符的顺序不变。为简单起见,标点符号和普通字母一样处理。例如输入字符串"I am a student. ",则输出"student. a am I"。
来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/fan-zhuan-dan-ci-shun-xu-lcof
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。【解法一】stringsteam的使用
class Solution { public: string reverseWords(string s) { stringstream sstream(s); // 使用stringstream来接收 string res; while(sstream) { string tempnull(" "); string temp; sstream>>temp; //每次接收一个单词 res.insert(0, temp); //头插该单词 res.insert(0, tempnull); //再头插一个空格 } res.erase(0, 2); return res; } };
剑指 Offer 12. 矩阵中的路径
给定一个 m x n 二维字符网格 board 和一个字符串单词 word 。如果 word 存在于网格中,返回 true ;否则,返回 false 。
单词必须按照字母顺序,通过相邻的单元格内的字母构成,其中“相邻”单元格是那些水平相邻或垂直相邻的单元格。同一个单元格内的字母不允许被重复使用。
例如,在下面的 3×4 的矩阵中包含单词 "ABCCED"(单词中的字母已标出)。
来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/ju-zhen-zhong-de-lu-jing-lcof
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。【解法一】dfs
int nextP[4][2] = {{0,1},{1,0},{0,-1},{-1,0}}; class Solution { public: bool flag = false; void dfs(vector<vector<char>>& board, string& word, vector<vector<bool>>& book, int row, int col, int curX, int curY, int wordindex) { if(wordindex == word.size()) { flag = true; } for(int i = 0; i < 4; i++) { int newX = curX + nextP[i][0]; int newY = curY + nextP[i][1]; if(newX<0||newX>=row || newY<0||newY>=col) continue; if(book[newX][newY]==false && word[wordindex]==board[newX][newY]) { book[curX][curY] = true; // 这次的dfs吸取教训只修改了值没有进行还原 dfs(board, word, book, row, col, newX, newY, wordindex+1); book[curX][curY] = false; // fds回溯时一定要还原状态; } } } bool exist(vector<vector<char>>& board, string word) { int row = board.size(); int col = board[0].size(); for(int i = 0; i < row; i++) { for(int j = 0; j < col; j++) { if(board[i][j] == word[0]) { vector<vector<bool>> book(row, vector<bool>(col, false)); dfs(board, word, book, row, col, i, j, 1); if(flag) return true; } } } return false; } };
面试题13. 机器人的运动范围
地上有一个m行n列的方格,从坐标 [0,0] 到坐标 [m-1,n-1] 。一个机器人从坐标 [0, 0] 的格子开始移动,它每次可以向左、右、上、下移动一格(不能移动到方格外),也不能进入行坐标和列坐标的数位之和大于k的格子。例如,当k为18时,机器人能够进入方格 [35, 37] ,因为3+5+3+7=18。但它不能进入方格 [35, 38],因为3+5+3+8=19。请问该机器人能够到达多少个格子?
【解法一】BFS 不要使用自己已经修改过得变量……
struct Node { int x; int y; Node(int a, int b) { x = a; y = b; } }; class Solution { public: int count = 0; int nextP[2][2] = {{0,1},{1,0}}; // 此题可以省略为俩个方向 int movingCount(int m, int n, int k) { queue<Node>q; q.push(Node(0,0)); vector<vector<bool>> book(m, vector<bool>(n,false)); book[0][0] = true; while(!q.empty()) { Node cur = q.front(); q.pop(); int i = cur.x, j = cur.y; int add = 0; while(i) { add += i%10; i /= 10; } while(j) { add += j%10; j /= 10; } if(add <= k) count++; else continue; for(int z = 0; z < 2; z++) { int newX = cur.x + nextP[z][0]; int newY = cur.y + nextP[z][1]; if(newX<0||newX>=m || newY<0||newY>=n) continue; if(book[newX][newY]==false) { q.push(Node(newX, newY)); book[newX][newY] = true; } } } return count; } };